#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.3 on Sun Mar 25 19:26:24 2012

# MeeTetris2.py
# 25.03.2012, N. Ramagnano

import wx
from board import *
from konfigurationdialog import KonfigurationDialog
from meereceiver import MeeReceiver
import serial
import threading

# begin wxGlade: extracode
# end wxGlade



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.CAPTION|wx.CLOSE_BOX|wx.MINIMIZE_BOX|wx.SYSTEM_MENU|wx.FULL_REPAINT_ON_RESIZE|wx.CLIP_CHILDREN
        wx.Frame.__init__(self, *args, **kwds)
        
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.menuitem_spiel = wx.Menu()
        self.menuitem_konfiguration = wx.MenuItem(self.menuitem_spiel, wx.NewId(), "&Konfiguration\tK", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_konfiguration)
        self.menuitem_spiel.AppendSeparator()
        self.menuitem_neustarten = wx.MenuItem(self.menuitem_spiel, wx.NewId(), "&Neustarten\tN", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_neustarten)
        self.menuitem_pause = wx.MenuItem(self.menuitem_spiel, wx.NewId(), "&Pause\tP", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_pause)
        self.menuitem_spiel.AppendSeparator()
        self.menuitem_vergroessern = wx.MenuItem(self.menuitem_spiel, wx.NewId(), u"Ver&grssern\tCtrl+G", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_vergroessern)
        self.menuitem_verkleinern = wx.MenuItem(self.menuitem_spiel, wx.NewId(), "Ver&kleinern\tCtrl+K", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_verkleinern)
        self.menuitem_spiel.AppendSeparator()
        self.menuitem_beenden = wx.MenuItem(self.menuitem_spiel, wx.NewId(), "&Beenden\tCtrl+Q", "", wx.ITEM_NORMAL)
        self.menuitem_spiel.AppendItem(self.menuitem_beenden)
        self.frame_1_menubar.Append(self.menuitem_spiel, "Spiel")
        self.menuitem_fragezeichen = wx.Menu()
        self.menuitem_ueber = wx.MenuItem(self.menuitem_fragezeichen, wx.NewId(), u"&ber ...", "", wx.ITEM_NORMAL)
        self.menuitem_fragezeichen.AppendItem(self.menuitem_ueber)
        self.frame_1_menubar.Append(self.menuitem_fragezeichen, "?")
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end
        self.frame_1_statusbar = self.CreateStatusBar(1, 0)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.OnMenuItemKonfiguration, self.menuitem_konfiguration)
        self.Bind(wx.EVT_MENU, self.OnMenuItemNeustarten, self.menuitem_neustarten)
        self.Bind(wx.EVT_MENU, self.OnMenuItemPause, self.menuitem_pause)
        self.Bind(wx.EVT_MENU, self.OnMenuItemVergroessern, self.menuitem_vergroessern)
        self.Bind(wx.EVT_MENU, self.OnMenuItemVerkleinern, self.menuitem_verkleinern)
        self.Bind(wx.EVT_MENU, self.OnMenuItemBeenden, self.menuitem_beenden)
        self.Bind(wx.EVT_MENU, self.OnMenuItemUeber, self.menuitem_ueber)
        # end wxGlade
        
        # create empty board
        self.board = Board(self,'left')
        self.GetSizer().Add(self.board, 1, wx.EXPAND, 0)
        self.static_line = wx.StaticLine(self, -1, style=wx.LI_VERTICAL, size=(5,-1))
        self.GetSizer().Add(self.static_line, 0, wx.EXPAND, 0)
        self.board2 = Board(self,'right')
        self.GetSizer().Add(self.board2, 1, wx.EXPAND, 0)
        self.static_line.Hide()
        self.board2.Hide()
        
        self.menuitem_neustarten.Enable(False)
        self.menuitem_pause.Enable(False)
        
        self.serialport = None
        self.keyboard_controlled_board = []
        self.mee_controlled_board = []
        
        self.meereceiver = MeeReceiver()
        
        self.thread = None
        self.thread_alive = threading.Event()
        
        self.GetSizer().Fit(self)
        self.GetSizer().SetSizeHints(self)
        self.Center()
        
        self.Bind(wx.EVT_KEY_DOWN, self.OnKeyDown) # bind to frame, not to panel. otherwise the arrow key events are filtered (dialog semantics)
        self.SetFocus() # ensure that the main window has the focus for the arrow key events
        self.configuring = False
        self.Bind(wx.EVT_KILL_FOCUS,self.GetFocus)
        self.Bind(wx.EVT_CLOSE, self.OnMenuItemBeenden)
        
        self.timer = wx.Timer(self)
        
        self.speedAtStart = 500
        self.speed = self.speedAtStart
        self.Bind(wx.EVT_TIMER, self.OnTimer, self.timer)
        self.Bind(EVT_BOARD_LINES_REMOVED, self.OnBoardLinesRemoved)
        self.Bind(EVT_BOARD_GAME_OVER, self.OnBoardGameOver)

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("MeeTetris2")
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = [""]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_myframe = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(sizer_myframe)
        sizer_myframe.Fit(self)
        self.Layout()
        self.Centre()
        # end wxGlade
        
    def OnMenuItemNeustarten(self, event): # wxGlade: MyFrame.<event_handler>
        if self.menuitem_neustarten.IsEnabled():
            self.start()
            self.RefreshStatusBar()

    def OnMenuItemPause(self, event): # wxGlade: MyFrame.<event_handler>
        if not self.board.isStarted or self.board.isWinner or self.board.isGameOver:
            return

        self.board.isPaused = not self.board.isPaused
        if self.board2.IsShown():
            self.board2.isPaused = not self.board2.isPaused

        if self.board.isPaused:
            self.timer.Stop()
        else:
            self.timer.Start(self.speed)
            self.RefreshStatusBar()

        self.board.Refresh()
        if self.board2.IsShown():
            self.board2.Refresh()

    def OnMenuItemBeenden(self, event): # wxGlade: MyFrame.<event_handler>
        self.StopSerialRxThread()
        self.Destroy()

    def OnKeyDown(self, event):
        if self.keyboard_controlled_board == []:
            event.Skip()
            return
        
        keycode = event.GetKeyCode()
        
        if keycode == wx.WXK_LEFT:
            self.ControlBoard(self.keyboard_controlled_board,'moveleft')
        elif keycode == wx.WXK_RIGHT:
            self.ControlBoard(self.keyboard_controlled_board,'moveright')
        elif keycode == wx.WXK_DOWN:
            self.ControlBoard(self.keyboard_controlled_board,'dropdown')
        elif keycode == wx.WXK_UP:
            self.ControlBoard(self.keyboard_controlled_board,'rotateleft')
        else:
            event.Skip()

    def ControlBoard(self,board,command):
        if not board.isStarted \
            or board.curPiece.shape() == Tetrominoes.NoShape \
            or board.isPaused \
            or board.isWinner:
            return
        
        if command == 'rotateleft':
            board.tryMove(board.curPiece.rotatedLeft(), board.curX, board.curY)
        elif command == 'moveleft':
            board.tryMove(board.curPiece, board.curX - 1, board.curY)
        elif command == 'dropdown':
            board.dropDown()
        elif command == 'moveright':
            board.tryMove(board.curPiece, board.curX + 1, board.curY)

    def StartSerialRxThread(self):
        """Start the receiver thread"""
        self.thread = threading.Thread(target=self.ThreadSerialRx)
        self.thread.setDaemon(1)
        self.thread_alive.set()
        self.thread.start()

    def StopSerialRxThread(self):
        """Stop the receiver thread, wait until it's finished."""
        if self.thread is not None:
            self.thread_alive.clear()   #clear alive event for thread
            self.thread.join()          #wait until thread has finished
            self.thread = None

    def ThreadSerialRx(self):
        if self.mee_controlled_board == []:
            return
        
        mee_list = [entry[1] for entry in self.mee_controlled_board]
        old_jup = [False]*len(mee_list)
        old_jleft = [False]*len(mee_list)
        old_jdown = [False]*len(mee_list)
        old_jright = [False]*len(mee_list)
        old_btnleft = [False]*len(mee_list)
        old_btnright = [False]*len(mee_list)
        
        while self.thread_alive.isSet():
            data = self.serialport.read(1)
            if data:
                data += self.serialport.read(self.serialport.inWaiting())
                parsed = self.meereceiver.parse(data)
                
                for id,x,y,z,jup,jleft,jdown,jright,jpush,btnleft,btnright in parsed:
                    #~ print id
                    if id in mee_list:
                        n = mee_list.index(id)
                        board = self.mee_controlled_board[n][0]
                        if jup and not old_jup[n]:
                            self.ControlBoard(board,'rotateleft')
                        elif jleft and not old_jleft[n]:
                            self.ControlBoard(board,'moveleft')
                        elif jdown and not old_jdown[n]:
                            self.ControlBoard(board,'dropdown')
                        elif jright and not old_jright[n]:
                            self.ControlBoard(board,'moveright')
                        elif btnleft and not old_btnleft[n]:
                            evt = wx.CommandEvent(wx.wxEVT_COMMAND_MENU_SELECTED, self.menuitem_neustarten.GetId()) 
                            evt.SetEventObject(self) 
                            wx.PostEvent(self.GetEventHandler(),evt)
                        elif btnright and not old_btnright[n]:
                            evt = wx.CommandEvent(wx.wxEVT_COMMAND_MENU_SELECTED, self.menuitem_pause.GetId()) 
                            evt.SetEventObject(self) 
                            wx.PostEvent(self.GetEventHandler(),evt)
                        old_jup[n] = jup
                        old_jleft[n] = jleft
                        old_jdown[n] = jdown
                        old_jright[n] = jright
                        old_btnleft[n] = btnleft
                        old_btnright[n] = btnright
    
    def OnTimer(self, event):
        if self.board.isWaitingAfterLine:
            self.board.isWaitingAfterLine = False
            self.board.newPiece()
        else:
            self.board.oneLineDown()
        
        if self.board2.IsShown():
            if self.board2.isWaitingAfterLine:
                self.board2.isWaitingAfterLine = False
                self.board2.newPiece()
            else:
                self.board2.oneLineDown()

    def OnBoardLinesRemoved(self, event):
        self.timer.Stop()
        if self.board2.IsShown():
            level = max(self.board.numLinesRemoved,self.board2.numLinesRemoved)/10
        else:
            level = self.board.numLinesRemoved/10
        
        self.speed = int(1000.0/(1000.0/self.speedAtStart + level*0.2))
        #~ print "time=%.3fs freq=%.3fHz" % (self.speed/1000.0, 1000.0/self.speed)
        self.timer.Start(self.speed)
        self.RefreshStatusBar()
    
    def OnBoardGameOver(self, event):
        self.timer.Stop()
        if event.GetId()==self.board.GetId():
            self.board2.isWinner = True
        else:
            if event.GetId()==self.board2.GetId():
                self.board.isWinner = True
        
        self.board.Refresh()
        self.board2.Refresh()
        self.RefreshStatusBar()

    def start(self):
        if self.board.isPaused:
            return

        self.board.isGameOver = False
        self.board.isWinner = False
        self.board.isStarted = True
        self.board.isPaused = False
        self.board.isWaitingAfterLine = False
        self.board.numLinesRemoved = 0
        self.board.clearBoard()
        self.board.newPiece()
        
        if self.board2.IsShown():
            self.board2.isGameOver = False
            self.board2.isWinner = False
            self.board2.isStarted = True
            self.board2.isPaused = False
            self.board2.isWaitingAfterLine = False
            self.board2.numLinesRemoved = 0
            self.board2.clearBoard()
            self.board2.newPiece()
        
        self.speed = self.speedAtStart
        self.timer.Start(self.speed)

    def RefreshStatusBar(self):
        if self.board2.IsShown():
            level = max(self.board.numLinesRemoved,self.board2.numLinesRemoved)/10
        else:
            level = self.board.numLinesRemoved/10
        self.frame_1_statusbar.SetStatusText("Level: %d" % (level + 1,), 0)

    def GetFocus(self, event):
        if not self.configuring:
            self.SetFocus()
    
    def OnMenuItemKonfiguration(self, event): # wxGlade: MyFrame.<event_handler>
        self.configuring = True
        self.timer.Stop()
        
        if self.serialport != None:
            self.StopSerialRxThread()
            self.serialport.close()
        dlg = KonfigurationDialog(self, -1)
        if dlg.ShowModal() != wx.ID_OK:
            if self.board.isStarted and not self.board.isPaused:
                if self.serialport != None:
                    self.serialport.open()
                    self.StartSerialRxThread()
                self.timer.Start(self.speed)
            return
        
        self.configuring = False
        
        self.keyboard_controlled_board = []
        self.mee_controlled_board = []
        
        for n,s in dlg.player_available:
            if s == dlg.combo_box_spieler1.GetValue():
                if n == -1:
                    self.keyboard_controlled_board = self.board
                else:
                    self.mee_controlled_board.append((self.board,n))
        
        
        if dlg.combo_box_spieler2.Enabled and dlg.combo_box_spieler2.GetValue() != "niemand":
            for n,s in dlg.player_available:
                if s == dlg.combo_box_spieler2.GetValue():
                    if n == -1:
                        self.keyboard_controlled_board = self.board2
                    else:
                        self.mee_controlled_board.append((self.board2,n))
            self.board2.Show()
            self.static_line.Show()
        else:
            self.board2.Hide()
            self.static_line.Hide()
        
        if self.serialport != None:
            self.StopSerialRxThread()
            self.serialport.close()
            self.serialport = None
        
        if self.mee_controlled_board != []:
            # open serial port
            self.serialport = serial.Serial(dlg.combo_box_serialport.GetValue(),baudrate=115200,timeout=0.5)
            self.StartSerialRxThread()
        
        self.GetSizer().Fit(self)
        self.GetSizer().SetSizeHints(self)
        self.Center()
        self.RefreshStatusBar()
        
        self.menuitem_neustarten.Enable(True)
        self.menuitem_pause.Enable(True)
        
        self.board.isPaused = False
        self.board2.isPaused = False
        self.start()
        
        dlg.Destroy()

    def OnMenuItemVergroessern(self, event): # wxGlade: MyFrame.<event_handler>
        self.board.bigger()
        self.board2.bigger()

    def OnMenuItemVerkleinern(self, event): # wxGlade: MyFrame.<event_handler>
        self.board.smaller()
        self.board2.smaller()

    def OnMenuItemUeber(self, event): # wxGlade: MyFrame.<event_handler>
        dlg = wx.MessageDialog(self, 'MeeTetris2\nVersion: 20120420\nAutor: Nicola Ramagnano\n\nTeile dieses Programmes stammen aus:\nhttp://zetcode.com/wxpython/thetetrisgame/', 'ber ...', wx.OK|wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    def OnMenuItemHilfe(self, event): # wxGlade: MyFrame.<event_handler>
        pass

# end of class MyFrame


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
