#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.3 on Sun Apr 01 16:10:31 2012

# konfigurationdialog.py
# 01.04.2012, N. Ramagnano

import wx
from meereceiver import MeeReceiver
import serial

# begin wxGlade: extracode
# end wxGlade



class KonfigurationDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: KonfigurationDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE|wx.FULL_REPAINT_ON_RESIZE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, "Serieller Port:")
        self.combo_box_serialport = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.label_2 = wx.StaticText(self, -1, "Spieler 1:")
        self.combo_box_spieler1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.label_3 = wx.StaticText(self, -1, "Spieler 2:")
        self.combo_box_spieler2 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.button_1 = wx.Button(self, wx.ID_OK, "")
        self.button_2 = wx.Button(self, wx.ID_CANCEL, "")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_COMBOBOX, self.OnComboboxSerialPort, self.combo_box_serialport)
        self.Bind(wx.EVT_COMBOBOX, self.OnComboboxSpieler1, self.combo_box_spieler1)
        self.Bind(wx.EVT_COMBOBOX, self.OnComboboxSpieler2, self.combo_box_spieler2)
        # end wxGlade
        
        
        self.serialports_available = self.getSerialPortsAvailable()
        self.player_available = [(-1,"Tastatur")]
        
        for n,s in self.serialports_available:
            self.combo_box_serialport.Append(s)
        
        if len(self.serialports_available):
            self.combo_box_serialport.SetSelection(len(self.serialports_available)-1)
            self.combo_box_serialport.SetFocus()
            self.OnComboboxSerialPort(None)
        else:
            self.combo_box_serialport.Enable(False)
            self.combo_box_spieler1.Append("Tastatur")
            self.combo_box_spieler1.SetSelection(0)
            self.combo_box_spieler1.SetFocus()
            self.combo_box_spieler2.Enable(False)
            self.player_available = [(-1,"Tastatur")]
        

    def __set_properties(self):
        # begin wxGlade: KonfigurationDialog.__set_properties
        self.SetTitle("Konfiguration")
        self.SetFocus()
        self.button_1.SetDefault()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: KonfigurationDialog.__do_layout
        grid_sizer_1 = wx.GridSizer(4, 2, 0, 0)
        grid_sizer_1.Add(self.label_1, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(self.combo_box_serialport, 0, wx.ALL|wx.EXPAND, 0)
        grid_sizer_1.Add(self.label_2, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(self.combo_box_spieler1, 0, wx.ALL|wx.EXPAND, 0)
        grid_sizer_1.Add(self.label_3, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_1.Add(self.combo_box_spieler2, 0, wx.ALL|wx.EXPAND, 0)
        grid_sizer_1.Add(self.button_1, 1, wx.ALL|wx.EXPAND, 0)
        grid_sizer_1.Add(self.button_2, 0, wx.ALL|wx.EXPAND, 1)
        self.SetSizer(grid_sizer_1)
        grid_sizer_1.Fit(self)
        self.Layout()
        self.Centre()
        # end wxGlade

    def getSerialPortsAvailable(self):
        """Scan for available ports. Return a list of tuples (num, name)."""
        available = []
        for i in range(256):
            try:
                s = serial.Serial(i)
                available.append( (i, s.name))
                s.close()
            except serial.SerialException:
                pass
        return available
        
    def getMeeControllersAvailable(self, serialport):
        """Scan for available Mee-Controllers on the selected serial port. Return a list [id0, id1, ...]"""
        # open port
        s = serial.Serial(serialport,baudrate=115200,timeout=0.5)
        data = s.read(10000)
        # detect available Mee receivers
        meereceiver = MeeReceiver()
        parsed = meereceiver.parse(data)
        l = [x[0] for x in parsed]
        l = list(set(l))
        l.sort()
        s.close()
        return l
        
    def OnComboboxSpieler1(self, event): # wxGlade: KonfigurationDialog.<event_handler>
        self.combo_box_spieler2.Clear()
        self.combo_box_spieler2.Append("niemand")
        for n,s in self.player_available:
            pass
            if s != self.combo_box_spieler1.GetValue():
                self.combo_box_spieler2.Append(s)
        self.combo_box_spieler2.SetSelection(0)

    def OnComboboxSpieler2(self, event): # wxGlade: KonfigurationDialog.<event_handler>
        pass
    
    def OnComboboxSerialPort(self, event): # wxGlade: KonfigurationDialog.<event_handler>
        mee = self.getMeeControllersAvailable(self.serialports_available[self.combo_box_serialport.GetSelection()][1])
        self.player_available = [(-1,"Tastatur")]
        for m in mee:
            self.player_available.append((m,"Mee %d" % m))
        
        self.combo_box_spieler1.Clear()
        for n,s in self.player_available:
            self.combo_box_spieler1.Append(s)
        self.combo_box_spieler1.SetSelection(0)
        
        self.OnComboboxSpieler1(None)

# end of class KonfigurationDialog


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    dialog_1 = KonfigurationDialog(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
